#include <inttypes.h>
#include <signal.h>
#include <stdio.h>
#include <sys/epoll.h>
#include <sys/timerfd.h>
#include <sys/signalfd.h>
#include <unistd.h>

#define MAX_EVENTS 1000

int main(void)
{
	int i, k;
	int efd, tfd[MAX_EVENTS];
	struct itimerspec timer[MAX_EVENTS];
	uint64_t count;

	struct epoll_event ev, events[MAX_EVENTS];
	ssize_t nr_events;

	efd = epoll_create1(0);

	for (i = 0; i < MAX_EVENTS; i++)
	{
		tfd[i] = timerfd_create(CLOCK_MONOTONIC, 0);
		timer[i].it_interval.tv_sec = 0;
		timer[i].it_interval.tv_nsec = i*1000;
		timer[i].it_value.tv_sec = 0;
		timer[i].it_value.tv_nsec = i*1000;
		timerfd_settime(tfd[i], 0, &timer[i], NULL);

		ev.events = EPOLLIN;
		ev.data.fd = tfd[i];
		epoll_ctl(efd, EPOLL_CTL_ADD, tfd[i], &ev);
	}

	for (;;) {
		nr_events = epoll_wait(efd, events, MAX_EVENTS, -1);
		for (i = 0; i < nr_events; i++) {
			for (k = 0; k < MAX_EVENTS; k++)
			{
				if (events[i].data.fd == tfd[k]) {
					read(tfd[k], &count, sizeof(count));
//					printf("%d\n", k);
				} 
			}
		}
	}
	return 0;
}
